/* SPDX-License-Identifier: LGPL-2.1+ */
/******************************************************************************
 * Copyright (c) Huawei Technologies Co., Ltd. 2020. Allrights reserved
 * Description: isulad utils
 * Author: lifeng
 * Create: 2020-04-11
******************************************************************************/
#ifndef __ISULAD_PATH_H_
#define __ISULAD_PATH_H_

#include <stdbool.h>

/*
 * cleanpath is similar to realpath of glibc, but not expands symbolic links,
 * and not check the existence of components of the path.
 */
char *cleanpath(const char *path, char *realpath, size_t realpath_len);

// FollowSymlinkInScope is a wrapper around evalSymlinksInScope that returns an
// absolute path. This function handles paths in a platform-agnostic manner.
char *follow_symlink_in_scope(const char *fullpath, const char *rootpath);

// Rel returns a relative path that is lexically equivalent to targpath when
// joined to basepath with an intervening separator. That is,
// Join(basepath, Rel(basepath, targpath)) is equivalent to targpath itself.
// On success, the returned path will always be relative to basepath,
// even if basepath and targpath share no elements.
// An error is returned if targpath can't be made relative to basepath or if
// knowing the current working directory would be necessary to compute it.
// Rel calls Clean on the result.
char *path_relative(const char *basepath, const char *targpath);

#endif
